{ -- TextTool.inc -- Bildschirmgestaltung -- c by FK -- Feb. 96 -- }


PROCEDURE Cursor(sichtbar:BOOLEAN);
{schaltet Cursor aus: FALSE und wieder an: TRUE}

VAR reg : REGISTERS;

BEGIN
 reg.ah:=1;
 IF sichtbar THEN BEGIN
                   reg.ch:=6;
                   reg.cl:=7
                  END
             ELSE BEGIN
                   reg.ch:=32;
                   reg.cl:=7;
                  END;
 INTR(16,reg);  {fhrt Software-Interrupt aus}
END;

PROCEDURE TextFarbe(v,h:INTEGER);
BEGIN
 TEXTCOLOR(v);TEXTBACKGROUND(h);
END;

PROCEDURE ASCIITextLesen(DiskettenDatei:STRING; s,z,Anzahl:INTEGER);
{liest Anzahl Zeilen aus einer Diskettendatei und gibt sie auf Position s,z
aus}
VAR TextDatei : TEXT;
    i         : INTEGER;
    T         : STRING[80];
BEGIN
 ASSIGN(TextDatei,DiskettenDatei);        {Herstellung der logischen Verbindung}
 RESET(TextDatei);                        {Textdatei wird zum Lesen geffnet}
 FOR i:=1 TO Anzahl DO
  BEGIN
   READLN(TextDatei,T);                   {Textzeile wird gelesen}
   GOTOXY(s,i+z-1);WRITE(T);              {Textzeile wird ausgegeben}
  END;
 CLOSE(TextDatei);
END;

PROCEDURE ASCIITextZeileLesen(DiskettenDatei:STRING; s,z,Zeile:INTEGER);
{liest eine Zeile aus einer Diskettendatei und gibt sie auf Position s,z aus}
VAR TextDatei : TEXT;
    i         : INTEGER;
    T         : STRING[80];
BEGIN
 ASSIGN(TextDatei,DiskettenDatei);        {Herstellung der logischen Verbindung}
 RESET(TextDatei);                        {Textdatei wird zum Lesen geffnet}
 FOR i:=1 TO Zeile DO
  BEGIN
   READLN(TextDatei,T);                   {Textzeile wird gelesen}
   IF i=Zeile THEN BEGIN GOTOXY(s,z);WRITE(T) END   {Textzeile wird ausgegeben}
              ELSE BEGIN GOTOXY(s,z);WRITE('');END;
  END;
 CLOSE(TextDatei);
END;

PROCEDURE ASCIITextSchreiben(DiskettenDatei:STRING; s,z,Anzahl:INTEGER);
{schreibt Anzahl Zeilen vom Bildschirm auf Position s,z in eine Diskettendatei}
VAR TextDatei : TEXT;
    i         : INTEGER;
    T         : STRING[80];
BEGIN
 ASSIGN(TextDatei,DiskettenDatei);     {Herstellung der logischen Verbindung}
 REWRITE(TextDatei);                   {Textdatei wird zum Schreiben geffnet}
 FOR i:=1 TO Anzahl DO
  BEGIN
   WRITELN(TextDatei,T);               {Textzeile wird geschrieben}
  END;
 CLOSE(TextDatei);
END;

PROCEDURE Rahmen(as,az,bs,bz,Art:INTEGER);
{zeichnet einen Rahmen: Art=1,2,3 mglich}

VAR s,z : INTEGER;
    Symb : STRING[6];

BEGIN
 CASE Art OF
  1: Symb:='ɻȼͺ';
  2: Symb:='ڿĳ';
  3: Symb:='******';
 END;
 GOTOXY(as,az);WRITE(Symb[1]);GOTOXY(bs,az);WRITE(Symb[2]);
 GOTOXY(as,bz);WRITE(Symb[3]);GOTOXY(bs,bz);WRITE(Symb[4]);
 FOR s:=as+1 TO bs-1 DO
     BEGIN
      GOTOXY(s,az);WRITE(Symb[5]);
      GOTOXY(s,bz);WRITE(Symb[5]);
     END;
 FOR z:=az+1 TO bz-1 DO
     BEGIN
      GOTOXY(as,z);WRITE(Symb[6]);
      GOTOXY(bs,z);WRITE(Symb[6]);
     END;
END;

PROCEDURE Fenster(as,az,bs,bz,v,h:INTEGER);
{erzeugt ein Farbfenster mit Farben v und h}
VAR s,z : INTEGER;
BEGIN
 WINDOW(as,az,bs,bz);
 TextFarbe(v,h);
 CLRSCR;
END;

PROCEDURE FensterMitRahmen(as,az,bs,bz,v,h,Art: INTEGER);
{setzt einen Rahmen in das Farbfenster}
BEGIN
 Fenster(as,az,bs,bz,v,h);
 Rahmen(2,1,bs-as,bz-az+1,Art);
END;

PROCEDURE Zeile(x,y,anz,att:BYTE);
{Frbt eine Zeile (bzw. Teil davon) mit dem Attribut att ein.
 MEM ist ein von PASCAL vordef. ARRAY, MEM setzt die Speicherzelle mit der
 Adresse [$B800:(y-1)*..] auf den Wert att. Dabei wird der Bildhintergrund
 nur in der Farbe gendert, nicht das Zeichen selbst.}

VAR i:INTEGER;
BEGIN
 i:=-1;
 Anz:=Anz*2;
 REPEAT
  INC(i,2);                               {i wird immer um 2 erhht}
  MEM[$B800:(y-1)*160+(x-1)*2+i]:=att;
 UNTIL i+2>Anz;
 GOTOXY(x+(Anz div 2),y)
END;

PROCEDURE Schatten(as,az,bs,bz,attr:BYTE);
{Legt einen Schatten mit dem angegebenen Textattribut(Farbe) um ein Fenster }

VAR i, Rand :BYTE;
BEGIN
  Rand:=1;                  {Rand = Randschattenbreite rechts}
  FOR i:=1 TO bz-az DO Zeile(bs+1,az+i,Rand,attr);
  Zeile(as+1,bz+1,bs-as+Rand,attr);
END;

PROCEDURE FensterKomplett(as,az,bs,bz,rv,Art,v,h,sf: BYTE);
{setzt Fenster vom Punkt A(as,az) zum Punkt B(bs,bz)
 mit Rahmen der Rahmenfarbe rv, Rahmenart Art (= 1,2 oder 3)
 Fensterfarben Vordergrund v, Hintergrund h
 Schattenfarbe sf auf schwarzem Hintergrund }
VAR i, Rand :BYTE;

BEGIN
 Fenster(as,az,bs,bz,rv,h);
 Rahmen(2,1,bs-as,bz-az+1,Art);
 Rand:=1;                  {Rand = Randschattenbreite rechts}
 FOR i:=1 TO bz-az DO Zeile(bs+1,az+i,Rand,sf);
 Zeile(as+1,bz+1,bs-as+Rand,sf);
 Fenster(as+2,az+1,bs-2,bz-1,v,h);
END;


PROCEDURE Hintergrund(v,h,Art: INTEGER);
{Stellt einen Hintergrund mit Symbolen der Art 1..12 dar}

VAR Symb : STRING[12];
       i : INTEGER;

BEGIN
 Symb:='*#@$'; Symb[9]:=#3;Symb[10]:=#6;Symb[11]:=#4;Symb[12]:=#5;
 Fenster(1,1,80,25,v,h);
 GOTOXY(1,2);
 FOR i:=1 TO 1840 DO WRITE(Symb[Art]);
END;


PROCEDURE WriteMarke(c:byte;s:string);
{ Im String wird der Teil, welcher in ~ eingeschlossen ist, mit der Farbe c
dargestellt. Der restliche String wird in der normalen Textfarbe ausgegeben.
Fehlerhafte Strings werden nicht dargestellt. }
var x,a,y,z:byte;
begin
  x:=pos('~',s);y:=pos('~~',s);z:=0;
  for a:=1 to length(s) do if s[a]='~' then z:=z+1;
  if z<>2 then y:=5;
  if (c>15) or (y<>0) then exit;
  a:=textattr;
  if x>1 then begin
                write(copy(s,1,x-1));delete(s,1,x)
              end
         else delete(s,1,1);
  textcolor(c);x:=pos('~',s);
  write(copy(s,1,x-1));delete(s,1,x);textattr:=a;write(s)
end;

PROCEDURE Melodie;
{erzeugt eine Melodie, die in der Prozedur Tondaten verschlsselt ist,
dabei gelten fr Frequenz die Werte der gleichmig temperierten Tonskale,
fr Pause gilt :    ganze Note        = 1000 (= 1s)
                    halbe Note        =  500
                    viertel Note      =  250
                    achtel Note       =  125
                    sechszehntel Note =   62
     punktierte Viertel = drei Achtel       =  375
     punktierte Achtel  = drei sechszehntel =  187 }
TYPE  Frequenz = WORD;
      Pause    = WORD;
VAR f : ARRAY[1..24] OF Frequenz;
    p : ARRAY[1..24] OF Pause;
    l : INTEGER;

   PROCEDURE TonDaten;
   BEGIN
    f[1]:=147 ; p[1]:=125 ; f[2]:=165 ; p[2]:=125 ;
    f[3]:=196 ; p[3]:=125 ; f[4]:=196 ; p[4]:=125 ;
    f[5]:=196 ; p[5]:=125 ; f[6]:=196 ; p[6]:=125 ;
    f[7]:=165 ; p[7]:=125 ; f[8]:=147 ; p[8]:=125 ;
    f[9]:=123 ; p[9]:=125 ; f[10]:=147 ; p[10]:=125 ;
    f[11]:=196 ; p[11]:=250 ; f[12]:=196 ; p[12]:=250 ;
    f[13]:=196 ; p[13]:=250 ; f[14]:=196 ; p[14]:=125 ;
    f[15]:=220 ; p[15]:=125 ; f[16]:=247 ; p[16]:=125 ;
    f[17]:=247 ; p[17]:=125 ; f[18]:=247 ; p[18]:=125 ;
    f[19]:=247 ; p[19]:=125 ; f[20]:=294 ; p[20]:=125 ;
    f[21]:=247 ; p[21]:=125 ; f[22]:=220 ; p[22]:=125 ;
    f[23]:=196 ; p[23]:=125 ; f[24]:=220 ; p[24]:=250 ;
   END;

BEGIN
 NOSOUND;
 TonDaten;
 FOR l:=1 TO 24 DO
     BEGIN
      SOUND(f[l]);
      DELAY(p[l]);NOSOUND;DELAY(100);
     END;
 NOSOUND;
END;